%Sortering av temperaturer

%Laster inn lydhastighetene som rådata
%clear all
%clc
load towed_ctd.mat

%Datasett 1

sr=towed_ctd(1).salt;
d=towed_ctd(1).z;
a=towed_ctd(1).x;
[x,y]=meshgrid(1:100,1:length(sr));
dybdeceller=[1 876 1229 1719 2157 2772 3144 3713 4063 4657 5068 5947 6355 7430 7877 8567 8978 9565 9964 10485 10891 11460 11891 12467 12966];
filter1=(ones(1,5))./5;
z=1:1:135; %Velger maks dybde til 135 meter.
r=1:1:24;
for j = 1:(length(dybdeceller)-1),
    sstr(j).salt = sr(dybdeceller(j):dybdeceller(j+1));
    sstr(j).z = d(dybdeceller(j):dybdeceller(j+1));
    sstr(j).r = mean(a(dybdeceller(j):dybdeceller(j+1)));
    rorg(j) = (sstr(j).r)/1000;
    [sstr(j).zsort,I] = sort(sstr(j).z) ;
    sstr(j).ssort = sstr(j).salt(I);
    sstr(j).ssortfilt = filter(filter1,1,sstr(j).ssort);
    sstr(j).ssortfilt = sstr(j).ssortfilt([5,5,5,5,5:end]);
    sstr(j).ssortfiltdec =  (sstr(j).ssortfilt(1:5:end));
    sstr(j).sinterp = rot90(interp1(sstr(j).zsort(1:5:end),sstr(j).ssortfiltdec,z),3);
    stot(:,j) = sstr(j).sinterp;
    
end
M=stot;
n=size(M,1); % depth
m=size(M,2); % range
for i=1:m            
    first_num = find(~isnan(M(:,i)),1,'first');
    M(1:first_num-1,i)=M(first_num,i);
    last_num = find(~isnan(M(:,i)),1,'last');
    M(last_num+1:n,i)=M(last_num,i);
end

for i=1:n            
    first_num = find(~isnan(M(i,:)),1,'first');
    M(i,1:first_num-1)=M(i,first_num);
    last_num = find(~isnan(M(i,:)),1,'last');
    M(i,last_num+1:m)=M(i,last_num);
end
xi=min(rorg):0.01:max(rorg);
zi=1:1:135;

sinterpr=interp2(rorg,z',M,xi,zi','spline');