%Sortering av temperaturer

%Laster inn lydhastighetene som rådata
% clear all
% clc
% load towed_ctd.mat

%Datasett 1

tr=towed_ctd(1).temp;
d=towed_ctd(1).z;
a=towed_ctd(1).x;
[x,y]=meshgrid(1:100,1:length(tr));
dybdeceller=[1 876 1229 1719 2157 2772 3144 3713 4063 4657 5068 5947 6355 7430 7877 8567 8978 9565 9964 10485 10891 11460 11891 12467 12966];
filter1=(ones(1,5))./5;
z=1:1:135; %Velger maks dybde til 135 meter.
r=1:1:24;
for j = 1:(length(dybdeceller)-1),
    tstr(j).t = tr(dybdeceller(j):dybdeceller(j+1));
    tstr(j).z = d(dybdeceller(j):dybdeceller(j+1));
    tstr(j).r = mean(a(dybdeceller(j):dybdeceller(j+1)));
    rorg(j) = (tstr(j).r)/1000;
    [tstr(j).zsort,I] = sort(tstr(j).z) ;
    tstr(j).tsort = tstr(j).t(I);
    tstr(j).tsortfilt = filter(filter1,1,tstr(j).tsort);
    tstr(j).csortfilt = tstr(j).tsortfilt([5,5,5,5,5:end]);
    tstr(j).tsortfiltdec =  tstr(j).tsortfilt(1:5:end);
    tstr(j).tinterp = rot90(interp1(tstr(j).zsort(1:5:end),tstr(j).tsortfiltdec,z),3);
    ttot(:,j) = tstr(j).tinterp;
    
end
M=ttot;
n=size(M,1); % depth
m=size(M,2); % range
for i=1:m            
    first_num = find(~isnan(M(:,i)),1,'first');
    M(1:first_num-1,i)=M(first_num,i);
    last_num = find(~isnan(M(:,i)),1,'last');
    M(last_num+1:n,i)=M(last_num,i);
end

for i=1:n            
    first_num = find(~isnan(M(i,:)),1,'first');
    M(i,1:first_num-1)=M(i,first_num);
    last_num = find(~isnan(M(i,:)),1,'last');
    M(i,last_num+1:m)=M(i,last_num);
end
xi=min(rorg):0.01:max(rorg);
zi=1:1:135;

tinterpr=interp2(rorg,z',M,xi,zi','spline');
% contourf(tinterpr);colorbar
% set(gca,'Ydir','reverse')