%Laster inn lydhastighetene som r?data
clear all
clc
load towed_ctd.mat
close all
%Datasett 1

cr=towed_ctd(1).soundvel;
d=towed_ctd(1).z;
a=towed_ctd(1).x;
[x,y]=meshgrid(1:100,1:length(cr));

dybdeceller=[1 876 1229 1719 2157 2772 3144 3713 4063 4657 5068 5947 6355 7430 7877 8567 8978 9565 9964 10485 10891 11460 11891 12467 12966];
filter1=(ones(1,5))./5;
z=1:1:135; %Velger maks dybde til 135 meter.
r=1:1:24;
for j = 1:(length(dybdeceller)-1),
    cstr(j).c = cr(dybdeceller(j):dybdeceller(j+1));
    cstr(j).z = d(dybdeceller(j):dybdeceller(j+1));
    cstr(j).r = mean(a(dybdeceller(j):dybdeceller(j+1)));
    rorg(j) = (cstr(j).r)/1000;
    [cstr(j).zsort,I] = sort(cstr(j).z) ;
    cstr(j).csort = cstr(j).c(I);
    cstr(j).csortfilt = filter(filter1,1,cstr(j).csort);
    cstr(j).csortfilt = cstr(j).csortfilt([5,5,5,5,5:end]);
    cstr(j).csortfiltdec =  cstr(j).csortfilt(1:5:end);
    cstr(j).cinterp = rot90(interp1(cstr(j).zsort(1:5:end),cstr(j).csortfiltdec,z),3);
    ctot(:,j) = cstr(j).cinterp;

end
M=ctot;
n=size(M,1); % depth
m=size(M,2); % range
for i=1:m            
    first_num = find(~isnan(M(:,i)),1,'first');
    M(1:first_num-1,i)=M(first_num,i);
    last_num = find(~isnan(M(:,i)),1,'last');
    M(last_num+1:n,i)=M(last_num,i);
end

for i=1:n            
    first_num = find(~isnan(M(i,:)),1,'first');
    M(i,1:first_num-1)=M(i,first_num);
    last_num = find(~isnan(M(i,:)),1,'last');
    M(i,last_num+1:m)=M(i,last_num);
end
xi=min(rorg):0.01:max(rorg);
zi=1:1:135;

cinterpr=flipdim(interp2(rorg,z',M,xi,zi','spline'),2);
contourf(cinterpr,[1440:1:1490]);colorbar;set(gca,'Ydir','reverse')
