clear all
close all

[c1,c2]=lyd_profil;

X0=1000; frontbredde=1000; tilt=89;
xvec=0:100:10e3;
zvec=1:1:135;

X=repmat(xvec(:)',numel(zvec),1);
X0ofzvec=X0+zvec.*tand(tilt);
X0=repmat(X0ofzvec(:),1,size(X,2));
X=X-X0;                 % Skalerer X slik at tan funksjonene blir jevnt fordelt over hele omr?det
X=X./(0.5*frontbredde); % Skalerer X slik at den har verdien 1 ved halve frontbredden 
meld=0.5+0.5.*tanh(X);
figure
contourf(meld);colorbar;set(gca,'Ydir','reverse');
title('Blandefunksjon')
xlabel('avstand[m]')
ylabel('dybde[m]')
savefig('bredde_feature','pdf')
data1=repmat(c2(:),1,numel(xvec));
data2=repmat(c1(:),1,numel(xvec));

data=data1+(data2-data1).*meld;

figure
contourf(data);colorbar;set(gca,'Ydir','reverse');
title('Lydhastighetsfordeling')
xlabel('avstand[m]')
ylabel('dybde[m]')
savefig('bredde_feature','pdf')