function [c1,c2]=lyd_profil()
% Lager noen lydhastighetsprofiler
close all
clc
clear all
%hold on

c0 = 1500;
z = 1:1:135;
linear=0;
switch linear
    case 0
        epsilon = 0.00737;
        cmin_punkt=40;
        skalering=1;

        z_middel1 = 2.*((z-cmin_punkt)./cmin_punkt);
        z_middel2 = 1.*((z-cmin_punkt)./cmin_punkt);
        
        c1 = c0*(1+epsilon*(z_middel1-1+exp(-z_middel1.*skalering)));
        c2 = (c0+50)*(1+epsilon*(z_middel2-1+exp(-z_middel2.*skalering-0.2)));
        
        c1=c1';
        c2=c2';
    case 1
        forhold=10;
        g1=0.01; g2=forhold*g1;
        c1=c0+g1.*z;
        c2=(c0+20)+g2.*z;
        
end
% figure(30)
% plot(c1,-z)
% hold on
% plot(c2,-z,'r')
% grid
% ylabel('Dybde [m]')
% xlabel('Lydhastighet [m/s]')
% title('Linere lydhastighetsprofiler')